/*
 * Blitter.java
 *
 * Created on 12 de julio de 2006, 18:43
 */

package Flier_Match.FMCliente.video;
import java.awt.Color;
import java.awt.Font;
import java.util.ArrayList;
import java.util.Date;
import java.util.StringTokenizer;

import Flier_Match.FMCliente.sistema.Parametros;
import Flier_Match.FMRed.ListaRed;
import Flier_Match.FMRed.NodoRed;

import com.threed.jpct.FrameBuffer;
import com.threed.jpct.SimpleVector;
import com.threed.jpct.Texture;
/**
 *
 * @author  Luis Rocha
 * @version 
 */
public class Blitter {
	
    Texture numerosGrande;
    Texture cruz;
    Texture caracteresS;
    Texture caracteresM;
    Texture mira;
    
    Texture bordeSup;
    Texture bordeInf;
    Texture bordeDer;
    Texture bordeIzq;
    Texture esquinaSD;
    
    Texture radar;
    Texture nave;
    Texture medidorEnergia;
    Texture medidaEnergia;
    
    Texture fondoMenu;
    
    Texture fondoChat;
    
    int width;
    int height;
    
    private Parametros param;
    private ArrayList lista;
    private long tiempoActual;
    
    private GLFont g;
    
    public static int TIPO_CHAT = 3;
    public static int TIPO_SMALL = 1;
    public static int TIPO_MEDIUM = 2;
    /** Creates new Blitter */
    public Blitter(int aw, int ah, Parametros param) {
        
    	this.param=param;
    	cargarFuenteAWT ();
    	
    	lista=new ArrayList ();
    	
        width=aw;
        height=ah;
        
        cruz=new Texture (param.getPath ()+"Recursos/Blit/CRUZ.jpg");
        caracteresS=new Texture (param.getPath ()+"Recursos/Blit/LETRASS.jpg");
        caracteresM=new Texture (param.getPath ()+"Recursos/Blit/LETRASM1.jpg");
        numerosGrande=new Texture (param.getPath ()+"Recursos/Blit/NUMEROSGRANDE.jpg");
        mira=new Texture (param.getPath ()+"Recursos/Blit/MIRA2.jpg");
        
        bordeSup=new Texture (param.getPath ()+"Recursos/Blit/BORDESUP.jpg");
        bordeInf=new Texture (param.getPath ()+"Recursos/Blit/BORDEINF.jpg");
        bordeDer=new Texture (param.getPath ()+"Recursos/Blit/BORDEDER.jpg");
        bordeIzq=new Texture (param.getPath ()+"Recursos/Blit/BORDEIZQ.jpg");
        esquinaSD=new Texture (param.getPath ()+"Recursos/Blit/ESQUINASD.jpg");
        
        radar=new Texture (param.getPath ()+"Recursos/Blit/RADAR.jpg");
        nave=new Texture (param.getPath ()+"Recursos/Blit/NAVE.jpg");
        
        medidaEnergia=new Texture (param.getPath ()+"Recursos/Blit/MedidaEnergia.jpg");
        medidorEnergia=new Texture (param.getPath ()+"Recursos/Blit/MedidorEnergia.jpg");
        
        fondoMenu=new Texture (param.getPath ()+"Recursos/Blit/FONDOMENU.jpg");
        
        fondoChat=new Texture (param.getPath ()+"Recursos/Blit/BG_CHAT.jpg");
    }
    
    public void blitBordeSuperior (FrameBuffer buffer) {
        for (int i=0;i<=width;i=i+64) {
            buffer.blit (bordeSup, 0, 0, i/*xini*/, 0/*yini*/, 64, 64, false);
        }
        buffer.blit (esquinaSD, 0, 0, width-64, 0/*yini*/, 64, 64, false);
    }
    
    public void blitBordeInferior (FrameBuffer buffer) {
        for (int i=0;i<=width;i=i+32) {
            buffer.blit (bordeInf, 0, 0, i/*xini*/, height-32/*yini*/, 32, 32, true);
        }
    }
    
    public void blitBordeIzquierdo (FrameBuffer buffer) {
        for (int i=0;i<=height;i=i+32) {
            buffer.blit (bordeIzq, 0, 0, 0/*xini*/, i/*yini*/, 32, 32, true);
        }
    }
    
    public void blitBordeDerecho (FrameBuffer buffer) {
        for (int i=0;i<=height;i=i+32) {
            buffer.blit (bordeDer, 0, 0, width-32/*xini*/, i/*yini*/, 32, 32, true);
        }
    }
    
    public void blitRadar (FrameBuffer buffer, ListaRed Lista, NodoRed propio) {
    	float xf=0;
        float zf=0;
        
        if (propio!=null) {
        	
        	//System.out.println ("la direccion es: "+(propio.getDireccion ().rot.getZAxis ()));
        	SimpleVector carPos=propio.getPosicion();
            SimpleVector temp=new SimpleVector();
            
            float rot=propio.Yrot;
            float xrot=propio.Xrot;
            
            float dx=(float) buffer.getOutputWidth()/10f;
            float dy=(float) buffer.getOutputHeight()/10f;
            float carPosX=(buffer.getOutputWidth()-dx-50);
            float carPosY=dy+50;

            buffer.blit (radar, 0, 0, 0, height-256, 256, 256, true);
            
            NodoRed tempN=Lista.inicio;
            while (tempN!=null) {
            
               if (tempN!=propio) {
                  temp.x=tempN.getPosicion().x-carPos.x;
                  temp.z=tempN.getPosicion().z-carPos.z;
                  temp.rotateY(rot);

                  xf=temp.x;
                  zf=temp.z;

                  if (xf>-1000&&xf<1000&&zf>-1000&&zf<1000) {
                	 
                     int x=(int) ((xf/800f)*(float) dx);
                     int z=(int) ((zf/800f)*-(float) dy);
                     
                     if (xrot<90 && xrot>-90) {
                    	 buffer.blit(nave, 0, 0, 127+x, height-127+z, 8, 8, true);
                     } else {
                    	 buffer.blit(nave, 0, 0, 127+x, height-127-z, 8, 8, true);
                     }
                     
                  }
               }
               tempN=tempN.sig;
            }
        } else {
        	System.out.println ("Imposible mostrar el radar, de desconoce la posicion propia");
        }
        
        
    }
    
    /*
    public void blitRadar (FrameBuffer buffer, ListaRed Lista, NodoRed propio) {
        buffer.blit (radar, 0, 0, 0, height-256, 256, 256, true);
        
        NodoRed temp=Lista.inicio;
        while (temp!=null) {
            if (temp!=propio) {
                ubicar (buffer, temp.getPosicion (), propio.getPosicion (), propio.getDireccion ().rot.getZAxis ());
            }
            temp=temp.sig;
        }
    }
    
    public void ubicar (FrameBuffer buffer, SimpleVector PNave, SimpleVector PCentro, SimpleVector DZ) {
        //cada 10 unidades relativas de jpct sera un pixel en el radar
        //la capacidad del radar es: 200 es decir 2000 unidades relativas
        SimpleVector res=PNave.calcSub (PCentro);
        
        float ang= (float) Math.acos(DZ.length()/DZ.z);
        
        res.rotateY(ang);
        
        
        
        float distancia=res.length ();
        if (distancia<1000) {
            
            int X= (int) (res.x)/10;
            int Y= (int) (res.z)/10;
            
            //falta: mover XY con respecto a Direccion Z
            //el angulo para rotas a res se puede obtener angulo final - angulo inicial (asumiendo que solo hay xz creo)
            
            buffer.blit (nave, 0, 0, 127+X, height-127-Y, 8, 8, true);
        }
    }
    
    /*
    public void blitVida (FrameBuffer buffer, int vida) {
        buffer.blit (cruz, 0, 0, 5, 16, 32, 32, true);
        String temp=""+vida;
        for (int i=0;i<temp.length();i++) {
            int t=Integer.parseInt (""+temp.charAt (i));
            buffer.blit (numerosGrande, 0, t*25, 40+i*25, 17, 32, 25, true);
        }
    }*/
    
    public void blitVida (FrameBuffer buffer, int vida) {
        buffer.blit (cruz, 0, 0, 5, 16, 32, 32, true);
        String temp="0";
        if (vida>0) {
        	temp=""+vida;
        }
        for (int i=0;i<temp.length();i++) {
            int t=Integer.parseInt (""+temp.charAt (i));
            buffer.blit (numerosGrande, t*25, 0, 40+i*25, 17, 25, 32, true);
        }
    }
    
    public void blitMira (FrameBuffer buffer) {
        buffer.blit (mira, 0, 0, width/2-16, height/2-16, 32, 32, true);
    }
    
    public void blitEnergia (FrameBuffer buffer, int porcentaje, int yinicial) {
    	
    	buffer.blit (medidorEnergia, 0, 0, 0, yinicial, 64, 256, true);
    	
    	if (porcentaje>100)porcentaje=100;
    	if (porcentaje<0)porcentaje=0;
    	
    	int deltaEnergia=240-55;//porque en la imagen esta asi en pixeles
    	int cantidad=deltaEnergia*porcentaje/100;
    	
    	
    	buffer.blit (medidaEnergia, 0, (240-cantidad), 0, yinicial+(240-cantidad), 64, 256-(240-cantidad), true);
    }
    
    public void blitBorde (FrameBuffer buffer) {
        blitBordeDerecho (buffer);
        blitBordeIzquierdo (buffer);
        blitBordeInferior (buffer);
        blitBordeSuperior (buffer);
    }
    
    /**
     * Presenta el mensaje en pantalla usando el juego de caracteres Small
     * 
     * @param buffer es el FrameBuffer en el cual se aplicara el Blit
     * @param mensaje es el mensaje que se desea mostrar
     * @param alto es la posicion en Y de la pantalla donde empezar a escribir el mensaje
     * @return el alto de pantalla de ultima linea escrita
     */
    public int blitMensajeS (FrameBuffer buffer, String mensaje, int alto) {
    	
    	int maxAncho=param.getResolucion()[0];
    	int anchoActual=0;
    	for (int i=0;i<mensaje.length();i++) {
    		char temp=mensaje.charAt(i);
    		String id="3,24";
    		if (temp==' ') {
    			id="3,24";
    		}
    		else if (temp=='=') {
    			id="3,23";
    		}
    		else {
    			id=param.getLetraId (temp);
    		}
    		
    		if (id!=null) {
    			int xini=0;
        		int yini=0;
        		
        		StringTokenizer st=new StringTokenizer (id, ",");
        		
        		int columna=Integer.parseInt(st.nextToken());
        		int posicion=Integer.parseInt(st.nextToken());
        		
        		int ancho=12;

        		//System.out.println("Bliting letra: "+temp+", "+(id-1)*16+", "+0+", "+16*i+", "+60+", "+16+", "+16+", "+true);
        		anchoActual=anchoActual+ancho;
        		if (anchoActual>(maxAncho-anchoActual)) {
        			alto=alto+25;
        			anchoActual=0;
        		}
        		buffer.blit (caracteresS, (posicion-1)*ancho, (columna-1)*20, anchoActual, alto, ancho, 20, false);
        		
    		}
    		
    	}
    	return alto;
    }
    
    /**
     * Presenta el mensaje en pantalla usando el juego de caracteres Medium
     * 
     * @param buffer es el FrameBuffer en el cual se aplicara el Blit
     * @param mensaje es el mensaje que se desea mostrar
     * @param alto es la posicion en Y de la pantalla donde empezar a escribir el mensaje
     * @return el alto de pantalla de ultima linea escrita
     */
    public int blitMensajeM (FrameBuffer buffer, String mensaje, int alto, boolean transparente) {
    	
    	int maxAncho=param.getResolucion()[0];
    	int anchoActual=0;
    	
    	for (int i=0;i<mensaje.length();i++) {
    		char temp=mensaje.charAt(i);
    		String id="3,24";
    		if (temp==' ') {
    			id="3,24";
    		}
    		else if (temp=='=') {
    			id="3,23";
    		}
    		else {
    			id=param.getLetraId (temp);
    		}
    		
    		if (id!=null) {
    			int xini=0;
        		int yini=0;
        		
        		StringTokenizer st=new StringTokenizer (id, ",");
        		
        		int columna=Integer.parseInt(st.nextToken());
        		int posicion=Integer.parseInt(st.nextToken());
        		
        		int ancho=24;
        		
        		anchoActual=anchoActual+ancho-8;
        		//if (anchoActual>(maxAncho-anchoActual)) {
        		if (anchoActual>=maxAncho-40) {
        			System.out.println ("Escribiendo en nueva linea. MAXANCHO: "+maxAncho+" - AnchoActual: "+anchoActual);
        			alto=alto+50;
        			anchoActual=0;
        		}
        		//System.out.println("Bliting letra: "+temp+", "+(posicion-1)*ancho+", "+(columna-1)*40+", "+ancho*i+", "+80+", "+ancho+", "+40+", "+false);
        		
        		//System.out.println ("Haciendolo transparente: "+transparente);
        		buffer.blit (caracteresM, (posicion-1)*ancho, (columna-1)*40, anchoActual-8, alto, ancho, 40, transparente);
        		//buffer.blit (caracteresM, (posicion-1)*ancho, (columna-1)*40, anchoActual, alto, ancho, 40, true);
        		
    		}
    	}
    	return alto;
    }
    
    /**
     * Presenta el mensaje en pantalla usando letras de AWT, si el texto es mayor al ancho de la pantalla entonces solo escribira 100 chars por linea
     * 
     * @param buffer es el FrameBuffer en el cual se aplicara el Blit
     * @param mensaje es el mensaje que se desea mostrar
     * @param alto es la posicion en Y de la pantalla donde empezar a escribir el mensaje
     * @return el alto de pantalla de ultima linea escrita
     */
    public int blitMensajeAWT (FrameBuffer buffer, String mensaje, int alto, Color color) {
    	
    	int maxAncho=param.getResolucion()[0];
    	int anchoActual=24;
    	    	
    	if (g.getStringBounds(mensaje).width<maxAncho) {//si el mensaje entra en una sola linea
    		g.blitString(buffer, mensaje, anchoActual, alto, 0, color);
    		
    	} else {
    		int indice1=0;
    		
    		while (indice1<mensaje.length()) {
    			String mensaje1="";
    			if ((indice1+100)<mensaje.length())mensaje1=mensaje.substring(indice1, (indice1+100));
    			else mensaje1=mensaje.substring(indice1, mensaje.length());
    			
    			g.blitString(buffer, mensaje1, anchoActual, alto, 0, color);
    			alto=alto+g.getStringBounds(mensaje).height;
    			indice1=indice1+100;
    		}
    		
    	}
    	return alto+g.getStringBounds(mensaje).height;
    }
    
    /**
     * Implementa una cola de mensajes para asi poder tener varios mensajes en pantalla
     * 
     * @param mensaje es el mensaje que se desea mostrar
     * @param id identifica si es un mensaje tipo chat o del juego; 1:chat - 2:mensaje del juego
     * @param tiempo es el tiempo en milisegundos que el mensaje permanece activo y visible
     * 
     */
    public void agregarMensajes (String mensaje, int id, long tiempo) {
    	
    	Object mens []=new Object [3];
    	mens [0]=mensaje;
    	mens [1]=new Integer (id);
    	mens [2]=new Long (tiempo);
    	lista.add(mens);
    }
    
    
    
    /**
     * Muestra en pantalla todos los mensajes almacenados en la lista de mensajes, tambien valida su tiempo de vida.
     * El limite de caracteres para un texto de chat son 120 y para un texto del juego son 50. SI el texto del mensaje
     * excede esta cantidad sera truncado en los limites especificados.
     * 
     * @param buffer es el buffer en el cual se escribir el texto
     * @param delta es la diferencia de tiempo desde la ultima vez que se llamo al metodo
     */
    public void BlitTodosMensajes (FrameBuffer buffer) {
    	
    	long delta=0;
    	if (tiempoActual==0) tiempoActual=new Date ().getTime();
    	int alto1=60;
		int alto2=(int)((param.getResolucion())[1])/2;
		delta=(new Date ().getTime())-tiempoActual;
		
    	for (int i=0;i<lista.size();i++) {
    		Object mensaje[]=(Object [])lista.get(i);
    		String texto=(String)mensaje [0];
    		int id=((Integer)mensaje [1]).intValue();
    		long tiempo=((Long)mensaje [2]).longValue();
    		
    		tiempo=(tiempo-delta);
    		
    		if (tiempo<=0) {
    			lista.remove(i);
    			i=i-1;
    		} else {
    			if (id==1) {
    				if (texto.length()>120) texto=texto.substring(0, 120);
    				alto1=blitMensajeS (buffer, texto, alto1+25);
    			} else if (id==2) {
    				if (texto.length()>50) texto=texto.substring(0, 50);
    				alto2=blitMensajeM (buffer, texto, alto2+50, false);
    			} else if (id==3) {
    				alto1=blitMensajeAWT (buffer, texto, alto1, new Color (200, 255, 10));
    			}
    			mensaje [2]=new Long (tiempo);
    			lista.set(i, mensaje);
    		}
    		
    	}
    	tiempoActual=new Date ().getTime();
    }
    
    public void blitOnCenterScreen (FrameBuffer buffer, String textura) {

    	int ancho=param.getResolucion()[0];
    	int alto=param.getResolucion()[1];
    	
    	if (param.getResolucion()[0]>800) {
    		//System.out.println ("Blit ajustado");
    		buffer.blit(fondoMenu, 0, 0, (ancho-800)/2, (alto-600)/2, 800, 600, false);
    	} else {
    		//System.out.println ("Blit desde 0");
    		buffer.blit(fondoMenu, 0, 0, 0, 0, 800, 600, false);
    	}

    }
    
    public void cargarFuenteAWT () {
    	Font fuente=new Font ("Dialog", Font.PLAIN, 12);
    	g=GLFont.getGLFont(fuente);
    }
    
    /**
     * Muestra en pantalla el campo para que los clientes escriban el chat saliente
     * usando la letra de 32 pixeles.
     * 
     * @param buffer es el buffer en el cual se escribir el texto
     * @param texto es el texto que aparecera en el chat field
     */
    public int blitChatField (FrameBuffer buffer, String mensaje) {
    	int alto=param.getResolucion()[1]-100;
    	int anchoBG=param.getResolucion()[0]-81;
    	
    	//blitMensajeM (buffer, mensaje, alto, true);
    	
    	int maxAncho=param.getResolucion()[0];
    	int anchoActual=0;
    	
    	for (int j=0;j<=(anchoBG+80);j=j+80) {//anchoBG+80 para que dibuje un BG mas fuera del ultimo por si acaso
    		buffer.blit(fondoChat, 0, 0, j, alto, 80, 32, false);
    	}
    	
    	for (int i=0;i<mensaje.length();i++) {
    		char temp=mensaje.charAt(i);
    		String id="3,24";
    		if (temp==' ') {
    			id="3,24";
    		}
    		else if (temp=='=') {
    			id="3,23";
    		}
    		else if (temp==':') {
    			id="3,20";
    		}
    		else {
    			id=param.getLetraId (temp);
    			//System.out.println ("id de letra: "+id);
    		}
    		
    		if (id!=null) {
    			int xini=0;
        		int yini=0;
        		
        		StringTokenizer st=new StringTokenizer (id, ",");
        		
        		int columna=Integer.parseInt(st.nextToken());
        		int posicion=Integer.parseInt(st.nextToken());
        		
        		int ancho=24;
        		
        		anchoActual=anchoActual+ancho-6;
        		//if (anchoActual>(maxAncho-anchoActual)) {
        		if (anchoActual>=maxAncho-40) {
        			//System.out.println ("Escribiendo en nueva linea. MAXANCHO: "+maxAncho+" - AnchoActual: "+anchoActual);
        			alto=alto+50;
        			anchoActual=0;
        			for (int j=0;j<=anchoBG;j=j+80) {
                		buffer.blit(fondoChat, 0, 0, j, alto, 80, 32, false);
                	}
        		}
        		//System.out.println("Bliting letra: "+temp+", "+(posicion-1)*ancho+", "+(columna-1)*40+", "+ancho*i+", "+80+", "+ancho+", "+40+", "+false);
        		
        		buffer.blit (caracteresM, (posicion-1)*ancho, (columna-1)*40, anchoActual-6, alto, ancho, 40, true);
        		
        		
    		} else {
    			int h=temp;
    			//System.out.println ("id de letra no encontrado: "+temp+" - "+h);
    		}
    	}
    	return alto;
    }
    

}
